package com.qiaoba.common.database.mapper;

import cn.hutool.core.collection.CollUtil;
import cn.hutool.core.util.ObjectUtil;
import com.baomidou.mybatisplus.core.conditions.Wrapper;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.mapper.BaseMapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.core.toolkit.ReflectionKit;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.extension.toolkit.Db;
import com.qiaoba.common.web.utils.BeanCopyUtil;

import java.io.Serializable;
import java.util.Collection;
import java.util.List;
import java.util.Map;

/**
 * 自定义 Mapper 接口, 实现 自定义扩展
 *
 * @param <M> mapper 泛型
 * @param <T> table 泛型
 * @param <V> vo 泛型
 * @author ailanyin
 * @since 2023-04-23 17:20:32
 */
@SuppressWarnings("unchecked")
public interface BaseMapperPlus<M, T, V> extends BaseMapper<T> {


    /**
     * currentVoClass
     *
     * @return Vo
     */
    default Class<V> currentVoClass() {
        return (Class<V>) ReflectionKit.getSuperClassGenericType(this.getClass(), BaseMapperPlus.class, 2);
    }

    /**
     * currentModelClass
     *
     * @return model
     */
    default Class<T> currentModelClass() {
        return (Class<T>) ReflectionKit.getSuperClassGenericType(this.getClass(), BaseMapperPlus.class, 1);
    }

    /**
     * currentMapperClass
     *
     * @return mapper
     */
    default Class<M> currentMapperClass() {
        return (Class<M>) ReflectionKit.getSuperClassGenericType(this.getClass(), BaseMapperPlus.class, 0);
    }

    /**
     * 查询所有
     *
     * @return all lst
     */
    default List<T> selectList() {
        return this.selectList(new QueryWrapper<>());
    }

    /**
     * 批量新增
     *
     * @param entityList list
     * @return 结果
     */
    default boolean insertBatch(Collection<T> entityList) {
        return Db.saveBatch(entityList);
    }

    /**
     * 批量更新
     *
     * @param entityList list
     * @return 结果
     */
    default boolean updateBatchById(Collection<T> entityList) {
        return Db.updateBatchById(entityList);
    }


    /**
     * 批量插入或更新
     *
     * @param entityList list
     * @return 结果
     */
    default boolean insertOrUpdateBatch(Collection<T> entityList) {
        return Db.saveOrUpdateBatch(entityList);
    }


    /**
     * 批量插入(包含限制条数)
     *
     * @param entityList list
     * @param batchSize  最大调数
     * @return 结果
     */
    default boolean insertBatch(Collection<T> entityList, int batchSize) {
        return Db.saveBatch(entityList, batchSize);
    }


    /**
     * 批量更新(包含限制条数)
     *
     * @param entityList list
     * @param batchSize  最大调数
     * @return 结果
     */
    default boolean updateBatchById(Collection<T> entityList, int batchSize) {
        return Db.updateBatchById(entityList, batchSize);
    }


    /**
     * 批量插入或更新(包含限制条数)
     *
     * @param entityList list
     * @param batchSize  最大调数
     * @return 结果
     */
    default boolean insertOrUpdateBatch(Collection<T> entityList, int batchSize) {
        return Db.saveOrUpdateBatch(entityList, batchSize);
    }


    /**
     * 插入或更新
     *
     * @param entity entity
     * @return 结果
     */
    default boolean insertOrUpdate(T entity) {
        return Db.saveOrUpdate(entity);
    }

    /**
     * 查询Vo by id
     *
     * @param id 主键
     * @return Vo
     */
    default V selectVoById(Serializable id) {
        return selectVoById(id, this.currentVoClass());
    }

    /**
     * 根据 ID 查询
     *
     * @param id      主键
     * @param voClass Vo
     * @param <C>     泛型
     * @return Vo
     */
    default <C> C selectVoById(Serializable id, Class<C> voClass) {
        T obj = this.selectById(id);
        if (ObjectUtil.isNull(obj)) {
            return null;
        }
        return BeanCopyUtil.copy(obj, voClass);
    }

    /**
     * 通过Ids 查询 list
     *
     * @param idList ids
     * @return list
     */
    default List<V> selectVoBatchIds(Collection<? extends Serializable> idList) {
        return selectVoBatchIds(idList, this.currentVoClass());
    }

    /**
     * 通过Ids 查询 list
     *
     * @param idList  ids
     * @param voClass Vo
     * @param <C>     泛型
     * @return list
     */
    default <C> List<C> selectVoBatchIds(Collection<? extends Serializable> idList, Class<C> voClass) {
        List<T> list = this.selectBatchIds(idList);
        if (CollUtil.isEmpty(list)) {
            return CollUtil.newArrayList();
        }
        return BeanCopyUtil.copyList(list, voClass);
    }

    /**
     * selectVoByMap
     *
     * @param map map
     * @return Vo
     */
    default List<V> selectVoByMap(Map<String, Object> map) {
        return selectVoByMap(map, this.currentVoClass());
    }

    /**
     * selectVoByMap
     *
     * @param map     map
     * @param voClass Vo
     * @param <C>     泛型
     * @return Vo
     */
    default <C> List<C> selectVoByMap(Map<String, Object> map, Class<C> voClass) {
        List<T> list = this.selectByMap(map);
        if (CollUtil.isEmpty(list)) {
            return CollUtil.newArrayList();
        }
        return BeanCopyUtil.copyList(list, voClass);
    }

    /**
     * 根据条件查询一条记录
     *
     * @param wrapper 条件
     * @return Vo
     */
    default V selectVoOne(Wrapper<T> wrapper) {
        return selectVoOne(wrapper, this.currentVoClass());
    }

    /**
     * 根据条件查询一条记录
     *
     * @param wrapper 条件
     * @param voClass Vo
     * @param <C>     泛型
     * @return Vo
     */
    default <C> C selectVoOne(Wrapper<T> wrapper, Class<C> voClass) {
        T obj = this.selectOne(wrapper);
        if (ObjectUtil.isNull(obj)) {
            return null;
        }
        return BeanCopyUtil.copy(obj, voClass);
    }

    /**
     * 根据条件查询所有
     *
     * @param wrapper 条件
     * @return list
     */
    default List<V> selectVoList(Wrapper<T> wrapper) {
        return selectVoList(wrapper, this.currentVoClass());
    }

    /**
     * 根据条件查询所有
     *
     * @param wrapper 条件
     * @param voClass Vo
     * @param <C>     泛型
     * @return list vo
     */
    default <C> List<C> selectVoList(Wrapper<T> wrapper, Class<C> voClass) {
        List<T> list = this.selectList(wrapper);
        if (CollUtil.isEmpty(list)) {
            return CollUtil.newArrayList();
        }
        return BeanCopyUtil.copyList(list, voClass);
    }

    /**
     * 分页查询Vo
     *
     * @param page    分页对象
     * @param wrapper 条件
     * @param <P>     泛型
     * @return IPage
     */
    default <P extends IPage<V>> P selectVoPage(IPage<T> page, Wrapper<T> wrapper) {
        return selectVoPage(page, wrapper, this.currentVoClass());
    }

    /**
     * 分页查询Vo
     *
     * @param page    分页对象
     * @param wrapper 条件
     * @param voClass Vo
     * @param <C>     泛型
     * @param <P>     泛型
     * @return IPage
     */
    default <C, P extends IPage<C>> P selectVoPage(IPage<T> page, Wrapper<T> wrapper, Class<C> voClass) {
        IPage<T> pageData = this.selectPage(page, wrapper);
        IPage<C> voPage = new Page<>(pageData.getCurrent(), pageData.getSize(), pageData.getTotal());
        if (CollUtil.isEmpty(pageData.getRecords())) {
            return (P) voPage;
        }
        voPage.setRecords(BeanCopyUtil.copyList(pageData.getRecords(), voClass));
        return (P) voPage;
    }

}
